/********************************************************************************/
// this functions scales the Sharp GP2D12 aIR sensor output into cm
// * the function takes AD-converter values (adcval) and returns a distance 
//   in cm (ca. 10 - 80cm)
// * objects closer than 10 cm will lead to faulty distances with this sensor
// * the sensor is non-linear (stepwise linear approximation needed)

/*!
\brief computes usefull sensor values from Sharp infrared analog values
*/
int scale_aIR(int adcval) {
	if(adcval < 38) return(((53-adcval)*40)/15);
	if(adcval < 71) return(((104-adcval)*20)/33);
	return((179-adcval)*10/54);
}

